//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * エラー出力実装
 * @author Junpee
 */

#include <cstdlib>// exitに必要
#include "LampBasic.h"
#include "Core/System/StringMethod.h"
#include "Core/Debug/ErrorOutput.h"
#include "Core/Debug/Logger.h"
#include "Core/Debug/DebugStringTemporary.h"
#include "Input/System/LampInput.h"
#include "Graphics/System/LampGraphics.h"

namespace Lamp{

// エラーハンドラ
ErrorOutput::ErrorHandler ErrorOutput::handler_ =
	ErrorOutput::defaultErrorHandler;

// ロガー
Logger* ErrorOutput::logger_ = NULL;

//------------------------------------------------------------------------------
// 初期化
void ErrorOutput::initialize(const char* fileName){
	if(fileName == NULL){ return; }
	logger_ = new Logger(fileName);
}
//------------------------------------------------------------------------------
// 後始末
void ErrorOutput::finalize(){
	SafeDelete(logger_);
}
//------------------------------------------------------------------------------
// デバッグ時
#ifdef _DEBUG
//------------------------------------------------------------------------------
// エラー出力
int ErrorOutput::print(const char* format, ...){
	va_list args;
	va_start(args, format);
	int size = StdVsnprintf(DebugStringTemporary::buffer_,
		DebugStringTemporary::bufferSize_ - 1, format, args);
	if(size < 0){
		ErrorOut(String("エラー出力のフォーマットに失敗しました。"));
		return size;
	}
	DebugStringTemporary::buffer_[size] = '\0';
	va_end(args);
	// 最高優先度でロガーへ出力
	if(logger_ != NULL){
		logger_->output(
			Logger::fewLevel, String(DebugStringTemporary::buffer_));
		logger_->flush();
	}
	// 入力のロギングを行っていれば終了しておく
	if(LampInput::isLogging()){ LampInput::endLogging(); }
	// エラーハンドラの呼び出し
	(*handler_)(DebugStringTemporary::buffer_);
	return size;
}
//------------------------------------------------------------------------------
// エラー出力
int ErrorOutput::print(const String& string){
	// 最高優先度でロガーへ出力
	if(logger_ != NULL){
		logger_->output(Logger::fewLevel, string);
		logger_->flush();
	}
	// 入力のロギングを行っていれば終了しておく
	if(LampInput::isLogging()){ LampInput::endLogging(); }
	// エラーハンドラの呼び出し
	(*handler_)(string.getBytes());
	return string.getSize();
}
//------------------------------------------------------------------------------
// デフォルトエラーハンドラ
void ErrorOutput::defaultErrorHandler(const char* message){
	StdOutputDebugString("致命的なエラーが発生したので強制終了します\n");
	StdOutputDebugString(message);
	StdOutputDebugString("\n");
	StdPrintf("致命的なエラーが発生したので強制終了します\n%s\n", message);
	// デバッガで中断する。
	_asm{ int 3 }
	// メッセージ出力
	MessageBox(LampGraphics::getWindowHandle(), message,
		"致命的なエラーが発生したので強制終了します",
		(MB_OK | MB_ICONERROR | MB_APPLMODAL));
	// システムを強制終了
	std::exit(EXIT_FAILURE);
}
//------------------------------------------------------------------------------
// 非デバッグ時
#else // ! _DEBUG
//------------------------------------------------------------------------------
// エラー出力
int ErrorOutput::print(const char* format, ...){
	va_list args;
	va_start(args, format);
	int size = StdVsnprintf(DebugStringTemporary::buffer_,
		DebugStringTemporary::bufferSize_ - 1, format, args);
	if(size < 0){
		ErrorOut("エラー出力のフォーマットに失敗しました。");
		return size;
	}
	DebugStringTemporary::buffer_[size] = '\0';
	va_end(args);
	// 最高優先度でロガーへ出力
	if(logger_ != NULL){
		logger_->output(Logger::fewLevel,
			String(DebugStringTemporary::buffer_));
		logger_->flush();
	}
	// 入力のロギングを行っていれば終了しておく
	if(LampInput::isLogging()){ LampInput::endLogging(); }
	// エラーハンドラの呼び出し
	(*handler_)(DebugStringTemporary::buffer_);
	return size;
}
//------------------------------------------------------------------------------
// エラー出力
int ErrorOutput::print(const String& string){
	// 最高優先度でロガーへ出力
	if(logger_ != NULL){
		logger_->output(Logger::fewLevel, string);
		logger_->flush();
	}
	// 入力のロギングを行っていれば終了しておく
	if(LampInput::isLogging()){ LampInput::endLogging(); }
	// エラーハンドラの呼び出し
	(*handler_)(string.getBytes());
	return string.getSize();
}
//------------------------------------------------------------------------------
// デフォルトエラーハンドラ
void ErrorOutput::defaultErrorHandler(const char* message){
	StdPrintf("致命的なエラーが発生したので強制終了します\n%s\n", message);
	// メッセージ出力
	MessageBox(LampGraphics::getWindowHandle(), message,
		"致命的なエラーが発生したので強制終了します",
		(MB_OK | MB_ICONERROR | MB_APPLMODAL));
	// システムを強制終了
	std::exit(EXIT_FAILURE);
}
//------------------------------------------------------------------------------
#endif// End of _DEBUG
} // End of namespace Lamp
//------------------------------------------------------------------------------
